/*****************************************************************
 * Copyright (c) 2016 Texas Instruments and others
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *  Paul Gingrich - Initial API and implementation
 *****************************************************************/
var gc = gc || {};
gc.databind = gc.databind || {};

/**
* Interface for reading and writing values from an array of target cores.
* This interface is generally used to support device arrays of targets.
*
* @interface
* @extends gc.databind.IPollingPacketCodec
*/
gc.databind.IPollingDeviceArrayPacketCodec = function()
{
};

gc.databind.IPollingDeviceArrayPacketCodec.prototype = new gc.databind.IPollingPacketCodec();

/**
 * Start a read operation to read an array of values from each core in the device array.
 *
 * @param {Object} entity  - model specific info identifying which value to read from the target.
 * @param {Object} model - for register model, the model's 'this' pointer
 * @return {Promise} - A promise that is resolved with an array of values read from each of the target device cores.
 */
gc.databind.IPollingDeviceArrayPacketCodec.prototype.readAllValues = function(entity, model)
{
};

/**
 * Start a write operation to write a value to the target.
 *
 * @param {object} entity - model specific info identifying which value to write to the target.
 * @param {Object} value - An array of values to write to the target device cores.
 * @param {Object} model - for register model, the model's 'this' pointer
 * @returns {Promise} - A promise when the writeValue operation has completed.
 */
gc.databind.IPollingDeviceArrayPacketCodec.prototype.writeAllValues = function(entity, value, model)
{
};